void calcprop(double **Gamma, double ***ALPHA, double *****PROP, double ***AZ, double ***AZGam)
{
	int i, j, k, l, m, t, row, col;
	double u1, u2;

	for (k=1; k<=2; k++)		
		for (i=1; i<NO; i++)
			for (t=1; t<NT; t++) {
					AZGam[k][i][t]=0;

					for (j=1; j<NX; j++)
						AZGam[k][i][t]+=AZ[i][j][t]*Gamma[k][j];
			}

	for (k=1; k<=2; k++)
		for (i=1; i<NO; i++) {
			u1=exp(ALPHA[k][1][0]);
			u2=1+u1;
			
			PROP[k][i][1][1][0]=u1/u2;
			
			for (row=2; row<NC[k]-1; row++) {
				u1=exp(ALPHA[k][row][0]);
				
				PROP[k][i][1][row][0]=u1/((1+u1)*u2);
				
				u2*=(1+u1);
			}

			PROP[k][i][1][NC[k]-1][0]=1.0/u2;
		
			for (t=2; t<NT; t++)
				for (col=1; col<NC[k]; col++) {
					u1=exp(AZGam[k][i][t]+ALPHA[k][1][col]);
					u2=1+u1;
					
					PROP[k][i][t][1][col]=u1/u2;
					
					for (row=2; row<NC[k]-1; row++) {
						u1=exp(AZGam[k][i][t]+ALPHA[k][row][col]);
						
						PROP[k][i][t][row][col]=u1/((1+u1)*u2);
						
						u2*=(1+u1);
					}

					PROP[k][i][t][NC[k]-1][col]=1.0/u2;
				}
		}
	
	return ;
}
