#include <stdio.h>
#include <math.h>
#include <time.h>
#include <string.h>

#include "nrutil.c"
#include "def_con.h"

#include "array.c"
#include "choldc.c"
#include "cholsl.c"
#include "ran2.c"
#include "expdev.c"
#include "gasdev.c"
#include "gamdev.c"
#include "ludcmp.c"
#include "lubksb.c"
#include "iv.c"
#include "detem.c"

// dimensions
int *NC, *NY, *NH, *NK, *NM, *NZ, *NB, *NP;
// int NC[2], NY[2], NH[2], NK[2], NM[2], NZ[2], NB[2], NP[2];

// indicator matrix
int **IND, **ROAL, ***IDY, **ROY, ***CLY, **RefCate, *POS;
double ****IYY;
// int IND[2][NY2], ROAL[2][NY2], IDY[2][NY2][NK2], ROY[2][NY2], CLY[2][NY2][NK2], RefCate[2][NC2], POS[2];
// double IYY[2][NO][NY2][NT];

// prior input
int ***PALPA, ***PBETA, ***PALP, ***PBET, **RHO;
double PBET_BI, PBET_BETA, ***PMU, ****PLY, ****PBI, **PGamma, ***PALPHA, ****RH, ***pphi;
// int PALPA[2][NC2][NY2], PBETA[2][NC2][NY2], PALP[2][NC2][NM2], PBET[2][NC2][NM2], RHO[2][NC2];
// double PMU[2][NC2][NY2], PLY[2][NC2][NY2][NK2], PBI[2][NC2][NM2][NB2], PGamma[2][NX], PALPHA[2][NC2][NC2]
// double RH[2][NC2][NZ2][NZ2], pphi[2][NC2][2];

// tuning parameters
double *VAR_Gam, ***VAR_ALP, ***VAR_THR, *VAR_Omega, **VAR_phi, **VAR_y;
// double VAR_Gam[2], VAR_ALP[2][NC2][NC2], VAR_Omega[2], VAR_THR[2][NC2][NY2], VAR_phi[2][NC2], VAR_y[2][NY2];

// acceptance rate
int *Accept_GAM, ***Accept_ALP, ***Accept_THR, *Accept_Omega, **Accept_phi, **Accept_y;
// int Accept_GAM[2], Accept_ALP[2][NC2][NC2], Accept_THR[2][NC2][NY2], Accept_Omega[2], Accept_phi[2][NC2], Accept_y[2][NY2];

#include "read1.c"
#include "read2.c"
#include "read3.c"
#include "read4.c"
#include "read7.c"
#include "read8.c"

#include "calcprop.c"
#include "newid.c"
#include "calsm.c"
#include "newomega.c"
#include "geny3.c"
#include "newph.c"
#include "newmu.c"
#include "newly.c"
#include "newbi2.c"
#include "newphi3.c"
#include "newphi_non4.c"
#include "newgamalp.c"
#include "chan.c"
#include "chan2.c"
#include "permutation.c"
#include "sdat1.c"
#include "calG2.c"

int main()
{
	int   i, j, k, l, m, n, t, zc, postp, CIR, GIB;
	long  random;
	double temp, as, bl, Dbar1, Dbar2, Popt;
	double tmp1, tmp2, tmp3;

	// identity variable 
	int ***ZID, ***TID;
	// int ZID[2][NO][NT], TID[2][NO][NT];

	// data
	double ***AZ, ****YO, ****XO, ****TUE, ****Omega, ****Eta, ****XI, ****XIB;
	// double AZ[NO][NX][NT], YO[2][NO][NY2][NT], XO[2][NO][NY2][NT];
	// double TUE[2][NO][NK2][NT], Omega[2][NO][NK2][NT], Eta[2][NO][NM2][NT], XI[2][NO][NZ2][NT];
	// double XIB[2][NO][NB2][NT];

	// parameters
	double ***MU, ****LY, ***PSX, ****THRES, ****BI, ***PSD, ****PHI, ***phi,  **Gamma, ***ALPHA;
	double ***EPA, ***VPA, ***PA, ****EID, ****Pred, ****EOmega;
	// double MU[2][NC2][NY2], LY[2][NC2][NY2][NK2], PSX[2][NC2][NY2], THRES[2][NC2][NY2][2];
	// double BI[2][NC2][NM2][NB2], PSD[2][NC2][NM2], PHI[2][NC2][NZ2][NZ2], phi[2][NC2][2+NX];
	// double Gamma[2][NX], ALPHA[2][NC2][NC2];
	// double EPA[2][NC2][NP2], VPA[2][NC2][NP2], PA[2][NC2][NP2], EID[2][NO][NT][NC2], Pred[2][NT][NC2][NC2];
	// double EOmega[2][NO][NK2][NT];

	// aid parameters
	double ****INPH, **NEYO, *NYO, *GOmega, *GAZ, ****SIG, ****f, ***AZGam, *****PROP;
	// double INPH[2][NC2][NZ2][NZ2], NEYO[NO][NT], NYO[NY2], GOmega[NK2], GAZ[NX], SIG[2][NC2][NK2][NK2];
	// double f[2][NC2][NO][NT], AZGAM[2][NO][NT], PROP[2][NO][NT][NC2][NC2];

	// model fit
	double **D1, *D2, *D3;
	
	// local influence measure
	double ***FI, ***G, ***FI_stru, ****G_stru, ***FI_miss, ****G_miss, **FI_tran, ***G_tran, **FI_prior, **G_prior;

	// file
	FILE *dat;
	char name[50];

	// time
	clock_t start, finish;
	double Time;

	ZID=if3tensor(1, 2, 1, NO, 1, NT);
	TID=if3tensor(1, 2, 1, NO, 1, NT);

	AZ=f3tensor(1, NO, 1, NX, 1, NT);
	YO=array4(1, 2, 1, NO, 1, NY2, 1, NT);
	XO=array4(1, 2, 1, NO, 1, NY2, 1, NT);
	TUE=array4(1, 2, 1, NO, 1, NK2, 1, NT);
	Omega=array4(1, 2, 1, NO, 1, NK2, 1, NT);
	Eta=array4(1, 2, 1, NO, 1, NM2, 1, NT);
	XI=array4(1, 2, 1, NO, 1, NZ2, 1, NT);
	XIB=array4(1, 2, 1, NO, 1, NB2, 1, NT);

	MU=f3tensor(1, 2, 1, NC2, 1, NY2);
	LY=array4(1, 2, 1, NC2, 1, NY2, 1, NK2);
	PSX=f3tensor(1, 2, 1, NC2, 1, NY2);
	THRES=array4(1, 2, 1, NC2, 1, NY2, 0, 2);
	BI=array4(1, 2, 1, NC2, 1, NM2, 1, NB2);
	PSD=f3tensor(1, 2, 1, NC2, 1, NM2);
	PHI=array4(1, 2, 1, NC2, 1, NZ2, 1, NZ2);
	phi=f3tensor(1, 2, 1, NC2, 1, 2+NX);
	Gamma=matrix(1, 2, 1, NX);
	ALPHA=f3tensor(1, 2, 1, NC2, 0, NC2);

	EPA=f3tensor(1, 2, 1, NC2, 1, NP2);
	VPA=f3tensor(1, 2, 1, NC2, 1, NP2);
	PA=f3tensor(1, 2, 1, NC2, 1, NP2);
	EID=array4(1, 2, 1, NO, 1, NT, 1, NC2);
	Pred=array4(1, 2, 1, NT, 1, NC2, 1, NC2);
	
	EOmega=array4(1, 2, 1, NO, 1, NK2, 1, NT);
	
	INPH=array4(1, 2, 1, NC2, 1, NZ2, 1, NZ2);
	NEYO=matrix(1, NO, 1, NT);
	NYO=vector(1, NY2);
	GOmega=vector(1, NK2);
	GAZ=vector(1, NX);
	SIG=array4(1, 2, 1, NC2, 1, NK2, 1, NK2);
	f=array4(1, 2, 1, NC2, 1, NO, 1, NT);
	AZGam=f3tensor(1, 2, 1, NO, 1, NT);
	PROP=array5(1, 2, 1, NO, 1, NT, 1, NC2, 0, NC2);

	NC=ivector(1, 2);
	NY=ivector(1, 2);
	NH=ivector(1, 2);
	NK=ivector(1, 2);
	NM=ivector(1, 2);
	NZ=ivector(1, 2);
	NB=ivector(1, 2);
	NP=ivector(1, 2);
	
	IND=imatrix(1, 2, 1, NY2);
	ROAL=imatrix(1, 2, 1, NY2);
	IDY=if3tensor(1, 2, 1, NY2, 1, NK2);
	CLY=if3tensor(1, 2, 1, NY2, 1, NK2);
	ROY=imatrix(1, 2, 1, NY2);
	IYY=array4(1, 2, 1, NO, 1, NY2, 1, NT);
	RefCate=imatrix(1, 2, 1, NC2);
	POS=ivector(1, 2);

	PMU=f3tensor(1, 2, 1, NC2, 1, NY2);
	PLY=array4(1, 2, 1, NC2, 1, NY2, 1, NK2);
	PBI=array4(1, 2, 1, NC2, 1, NM2, 1, NB2);
	PGamma=matrix(1, 2, 1, NX);
	PALPHA=f3tensor(1, 2, 1, NC2, 0, NC2);
	PALPA=if3tensor(1, 2, 1, NC2, 1, NY2);
	PBETA=if3tensor(1, 2, 1, NC2, 1, NY2);
	PALP=if3tensor(1, 2, 1, NC2, 1, NM2);
	PBET=if3tensor(1, 2, 1, NC2, 1, NM2);
	RHO=imatrix(1, 2, 1, NC2);
	RH=array4(1, 2, 1, NC2, 1, NZ2, 1, NZ2);
	pphi=f3tensor(1, 2, 1, NC2, 1, 2+NX);
	
	VAR_Gam=vector(1, 2);
	VAR_ALP=f3tensor(1, 2, 1, NC2, 1, NC2);
	VAR_THR=f3tensor(1, 2, 1, NC2, 1, NY2);
	VAR_Omega=vector(1, 2);
	VAR_phi=matrix(1, 2, 1, NC2);
	VAR_y=matrix(1, 2, 1, NY2);
	
	Accept_GAM=ivector(1, 2);
	Accept_ALP=if3tensor(1, 2, 1, NC2, 1, NC2);
	Accept_THR=if3tensor(1, 2, 1, NC2, 1, NY2);
	Accept_Omega=ivector(1, 2);
	Accept_phi=imatrix(1, 2, 1, NC2);
	Accept_y=imatrix(1, 2, 1, NY2);
	
	D1=matrix(1, 2, 1, NO);
	D2=vector(1, NO);
	D3=vector(1, NO);
	
	FI=f3tensor(1, 2, 1, NO, 1, 5);
	G=f3tensor(1, 2, 1, NO, 1, 5);
	
	FI_stru=f3tensor(1, 2, 1, NC2, 1, NB2);
	G_stru=array4(1, 2, 1, NC2, 1, NB2, 1, NB2);
	
	FI_miss=f3tensor(1, 2, 1, NC2, 1, 1+NX);
	G_miss=array4(1, 2, 1, NC2, 1, 1+NX, 1, 1+NX);

	FI_tran=matrix(1, 2, 1, NX);
	G_tran=f3tensor(1, 2, 1, NX, 1, NX);
	
	FI_prior=matrix(1, 2, 1, 50);
	G_prior=matrix(1, 2, 1, 50);
	
	NC[1]=NC[2]=NC2;
	NY[1]=NY[2]=NY2;
	NK[1]=NK[2]=NK2;
	NM[1]=NM[2]=NM2;
	NZ[1]=NZ[2]=NZ2;
	NB[1]=NB[2]=NB2;
	NP[1]=NP[2]=NP2;
	POS[1]=POS[2]=POS2;

	read1();
	read7();
	read8();

	Time=0;
	start=clock();

	read2(AZ, YO);
	printf("Data read!\n");

	read3(MU, LY, PSX, THRES, BI, PSD, PHI, phi);
	read4(Gamma, ALPHA);

	for (k=1; k<=2; k++) {
		for (i=1; i<NO; i++)
			for (t=1; t<NT; t++) {				
				for (j=1; j<NK[k]; j++)
					Omega[k][i][j][t]=0;

				for (j=1; j<NM[k]; j++)
					Eta[k][i][j][t]=Omega[k][i][j][t];
			
				for (j=1; j<NZ[k]; j++)
					XI[k][i][j][t]=Omega[k][i][j+NM[k]-1][t];

				for (j=1; j<NZ[k]; j++)
					XIB[k][i][j][t]=XI[k][i][j][t];
				
				XIB[k][i][3][t]=XI[k][i][1][t]*XI[k][i][2][t];
				XIB[k][i][4][t]=XI[k][i][1][t]*XI[k][i][1][t];
				XIB[k][i][5][t]=XI[k][i][2][t]*XI[k][i][2][t];
				// nonlinear structural equation
				
				for (j=1; j<NC[k]; j++)
					EID[k][i][t][j]=0;
				
				for (j=1; j<NK[k]; j++)
					EOmega[k][i][j][t]=0;
			}

		for (zc=1; zc<NC[k]; zc++) {
			for (i=1; i<NP[k]; i++)
				EPA[k][zc][i]=VPA[k][zc][i]=0.0;
			
			for (i=1; i<NZ[k]; i++)
				for (j=1; j<=i; j++)
					INPH[k][zc][j][i]=INPH[k][zc][i][j]=PHI[k][zc][i][j];
			
			iv(INPH[k][zc], NZ[k]);
			
			RefCate[k][zc]=0;
			
			Accept_ALP[k][zc][0]=0;
			
			for (j=1; j<NC2; j++)
				Accept_ALP[k][zc][j]=0;
			
			for (j=1; j<NY2; j++)
				Accept_THR[k][zc][j]=0;
			
			Accept_phi[k][zc]=0;
		}
		
		RefCate[k][NC[k]-1]=1;
		
		Accept_GAM[k]=Accept_Omega[k]=0;
		
		for (j=1; j<NY2; j++)
			Accept_y[k][j]=0;
		
		for (t=1; t<NT; t++)
			for (i=1; i<NC2; i++)
				for (j=1; j<NC2; j++)
					Pred[k][t][i][j]=0;
	}

	for (k=1; k<=2; k++) {
		for (i=1; i<NO; i++) {
			for (j=1; j<=5; j++)
				G[k][i][j]=FI[k][i][j]=0;
		}

		for (zc=1; zc<NC[k]; zc++) {
			for (i=1; i<NB[k]; i++) {
				FI_stru[k][zc][i]=0;
				for (j=1; j<=i; j++)
					G_stru[k][zc][j][i]=G_stru[k][zc][i][j]=0;
			}
			
			for (i=1; i<1+NX; i++) {
				FI_miss[k][zc][i]=0;
				
				for (j=1; j<=i; j++)
					G_miss[k][zc][i][j]=G_miss[k][zc][j][i]=0;
			}
		}
		
		for (i=1; i<NX; i++) {
			FI_tran[k][i]=0;
			
			for (j=1; j<=i; j++)
				G_tran[k][i][j]=G_tran[k][j][i]=0;
		}
		
		for (i=1; i<=50; i++)
			G_prior[k][i]=FI_prior[k][i]=0;
		
		G_prior[k][1]=0.5*(NC[k]-1)*(NY[k]-1);
		// Perturbation of MU

		for (zc=1; zc<NC[k]; zc++) {
			for (j=1; j<NY[k]; j++)
				G_prior[k][2]+=0.5*ROY[k][j];
			// Perturbation of LY
			
			for (j=1; j<NM[k]; j++)
				G_prior[k][3]+=0.5*(NB[k]-1);
			// Perturbation of BI
		}	
		
		i=3;
			
		for (j=1; j<NY[k]; j++) {
			i++;
			for (zc=1; zc<NC[k]; zc++)
				G_prior[k][i]+=PALPA[k][zc][j];
		}
		// Perturbation of PSX[j]

		for (j=1; j<NM[k]; j++) {
			i++;
			for (zc=1; zc<NC[k]; zc++)
				G_prior[k][i]+=PALP[k][zc][j];
		}
		// Perturbation of PSD[j]
		
		G_prior[k][++i]=0.5*(1+NX)*(NC[k]-1);
		// Perturbation of phi
		
		G_prior[k][++i]=0.5*(NC[k]-2);
		// Perturbation of ALPHA[0]			
		
		G_prior[k][++i]=0.5*(NC[k]-1)*(NC[k]-2);
		// Perturbation of ALPHA
		
		G_prior[k][++i]=0.5*(NX-1);
		// Perturbation of GAMMA	
	}

	calcprop(Gamma, ALPHA,PROP, AZ, AZGam);

	for (k=1; k<=2; k++)
		for (i=1; i<NO; i++)
			for (t=1; t<NT; t++)
				for (zc=1; zc<NC[k]; zc++) {
					f[k][zc][i][t]=0;
					
					for (j=1; j<NY[k]; j++) {
						temp=YO[k][i][j][t]-MU[k][zc][j];
						for (l=1; l<NK[k]; l++)
							temp-=LY[k][zc][j][l]*Omega[k][i][l][t];
							
						f[k][zc][i][t]-=0.5*log(PSX[k][zc][j])+0.5*temp*temp/PSX[k][zc][j];
					}
					// measurement equation
					
					for (j=1; j<NM[k]; j++) {
						temp=Eta[k][i][j][t];
						for (l=1; l<NB[k]; l++)
							temp-=BI[k][zc][j][l]*XIB[k][i][l][t];
								
						f[k][zc][i][t]-=0.5*log(PSD[k][zc][j])+0.5*temp*temp/PSD[k][zc][j];
					}
					// structural equation
					
					temp=0;
					for (j=1; j<NZ[k]; j++) {
						temp+=0.5*XI[k][i][j][t]*INPH[k][zc][j][j]*XI[k][i][j][t];
						for (l=1; l<j; l++)
							temp+=XI[k][i][j][t]*INPH[k][zc][j][l]*XI[k][i][l][t];
					}
					
					f[k][zc][i][t]-=0.5*log(detem(PHI[k][zc], NZ[k]))+temp;
					//  exogenous latent variable
					
					for (j=1; j<NY[k]; j++) {
						temp=phi[k][zc][1]+phi[k][zc][2]*YO[k][i][j][t];
						
						for (l=1; l<NX; l++)
							temp+=phi[k][zc][2+l]*AZ[i][l][t];
						
						f[k][zc][i][t]+=IYY[k][i][j][t]*temp-log(1+exp(temp));
					}
					// nonignorable missingness
				}

	for (GIB=1; GIB<=MCAX; GIB++) {

		for (k=1; k<=2; k++)
			for (zc=1; zc<NC[k]; zc++)
				for (i=1; i<NO; i++)
					for (t=1; t<NT; t++)
						f[k][zc][i][t]=exp(f[k][zc][i][t]+15);

		newid(ZID, f, PROP);
	
		for (k=1; k<=2; k++)
			for (i=1; i<NO; i++)
				for (t=1; t<NT; t++)
					for (j=1; j<NY[k]; j++)
						if (IYY[k][i][j][t]) {
							zc=ZID[k][i][t];
							
							if (MAR) {
								random=rand();
								YO[k][i][j][t]=MU[k][zc][j]+gasdev(&random)*sqrt(PSX[k][zc][j]);
								for (l=1; l<NK[k]; l++)
									YO[k][i][j][t]+=LY[k][zc][j][l]*Omega[k][i][l][t];
							}
							// ignorable missing y
							else {
								for (l=1; l<NK[k]; l++)
									GOmega[l]=Omega[k][i][l][t];
								
								for (l=1; l<NX; l++)
									GAZ[l]=AZ[i][l][t];
								
								m=geny3(k, &YO[k][i][j][t], GOmega, GAZ, phi[k][zc], MU[k][zc][j], LY[k][zc][j], PSX[k][zc][j], VAR_y[k][j]);
								Accept_y[k][j]+=m;
							}
							// nonignorable missing y
						}

		calsm(LY, PSX, BI, PSD, INPH, SIG, VAR_Omega);		

		newomega(YO, Omega, Eta, XI, ZID, SIG, MU, LY, PSX, BI, PSD, INPH);
		
		for (k=1; k<=2; k++)
			for (i=1; i<NO; i++)
				for (t=1; t<NT; t++) {
					for (j=1; j<NZ[k]; j++)
						XIB[k][i][j][t]=XI[k][i][j][t];
					
					XIB[k][i][3][t]=XI[k][i][1][t]*XI[k][i][2][t];
					XIB[k][i][4][t]=XI[k][i][1][t]*XI[k][i][1][t];
					XIB[k][i][5][t]=XI[k][i][2][t]*XI[k][i][2][t];
					// nonlinear structural equation
				}
		
		for (k=1; k<=2; k++)
			for (zc=1; zc<NC[k]; zc++) {
				newph(PHI[k][zc], INPH[k][zc], XI[k], ZID[k], RHO[k][zc], RH[k][zc], NZ[k], zc);

				for (j=1; j<NY[k]; j++) {
					for (i=1; i<NO; i++)
						for (t=1; t<NT; t++) {
							NEYO[i][t]=YO[k][i][j][t];
							
							for (l=1; l<NK[k]; l++)
								NEYO[i][t]-=LY[k][ZID[k][i][t]][j][l]*Omega[k][i][l][t];
						}

					MU[k][zc][j]=newmu(NEYO, ZID[k], PSX[k][zc][j], PMU[k][zc][j], zc);

					for (i=1; i<NO; i++)
						for (t=1; t<NT; t++) 
							if (ZID[k][i][t]==zc) {			
								NEYO[i][t]=YO[k][i][j][t]-MU[k][zc][j];
								
								for (l=1; l<NK[k]; l++)
									if (!IDY[k][j][l])
										NEYO[i][t]-=LY[k][zc][j][l]*Omega[k][i][l][t];
							}

					newly(NEYO, Omega[k], ZID[k], LY[k][zc][j], &PSX[k][zc][j], PLY[k][zc][j],
							PALPA[k][zc][j], PBETA[k][zc][j], sigly, ROY[k][j], CLY[k][j], zc);
					
					for (i=1; i<NO; i++)
						for (t=1; t<NT; t++)
							if (ZID[k][i][t]==zc) {
								NEYO[i][t]=MU[k][zc][j];
								
								for (l=1; l<NK[k]; l++)
									NEYO[i][t]+=LY[k][zc][j][l]*Omega[k][i][l][t];
							}
				}

				for (j=1; j<NM[k]; j++) {

					for (i=1; i<NO; i++)
						for (t=1; t<NT; t++) 
							if (ZID[k][i][t]==zc)
								NEYO[i][t]=Eta[k][i][j][t];
								
					if (NON)
						newbi2(NEYO, XIB[k], ZID[k], BI[k][zc][j], &PSD[k][zc][j], PBI[k][zc][j],
								PALP[k][zc][j], PBET[k][zc][j], sigbi, NB[k], zc);
					else
						newbi2(NEYO, XIB[k], ZID[k], BI[k][zc][j], &PSD[k][zc][j], PBI[k][zc][j],
								PALP[k][zc][j], PBET[k][zc][j], sigbi, NZ[k], zc);								
					
				}
				// end of BI and PSD

				if (MAR) {
					m=newphi3(k, zc, &phi[k][zc][1], ZID[k], VAR_phi[k][zc]);
					Accept_phi[k][zc]+=m;
				}
				// end of ignorable phi
				else {
					m=newphi_non4(k, zc, phi[k][zc], YO[k], AZ, ZID[k], VAR_phi[k][zc]);
					Accept_phi[k][zc]+=m;
				}
				// end of nonignorable phi					
				
			}

		newgamalp(Gamma, ALPHA, ZID, AZ, AZGam, 1);

		chan(MU, LY, PSX, THRES, BI, PSD, PHI, phi, Gamma, ALPHA, PA);

		permutation(MU, PA);
		
		chan2(MU, LY, PSX, THRES, BI, PSD, PHI, phi, Gamma, ALPHA, PA);

		calcprop(Gamma, ALPHA, PROP, AZ, AZGam);

		for (k=1; k<=2; k++)
			for (i=1; i<NO; i++)
				for (t=1; t<NT; t++)
					for (zc=1; zc<NC[k]; zc++) {
						f[k][zc][i][t]=0;
						
						for (j=1; j<NY[k]; j++) {
							temp=YO[k][i][j][t]-MU[k][zc][j];
							for (l=1; l<NK[k]; l++)
								temp-=LY[k][zc][j][l]*Omega[k][i][l][t];
								
							f[k][zc][i][t]-=0.5*log(PSX[k][zc][j])+0.5*temp*temp/PSX[k][zc][j];
						}
						// measurement equation
						
						for (j=1; j<NM[k]; j++) {
							temp=Eta[k][i][j][t];
							for (l=1; l<NB[k]; l++)
								temp-=BI[k][zc][j][l]*XIB[k][i][l][t];

							f[k][zc][i][t]-=0.5*log(PSD[k][zc][j])+0.5*temp*temp/PSD[k][zc][j];
						}
						// structural equation
						
						temp=0;
						for (j=1; j<NZ[k]; j++) {
							temp+=0.5*XI[k][i][j][t]*INPH[k][zc][j][j]*XI[k][i][j][t];
							for (l=1; l<j; l++)
								temp+=XI[k][i][j][t]*INPH[k][zc][j][l]*XI[k][i][l][t];
						}
						
						f[k][zc][i][t]-=0.5*log(detem(PHI[k][zc], NZ[k]))+temp;
						// exogenous latent variable

						for (j=1; j<NY[k]; j++) {
							temp=phi[k][zc][1]+phi[k][zc][2]*YO[k][i][j][t];
							
							for (l=1; l<NX; l++)
								temp+=phi[k][zc][2+l]*AZ[i][l][t];
							
							f[k][zc][i][t]+=IYY[k][i][j][t]*temp-log(1+exp(temp));
						}
						// nonignorable missingness
					}

		if (GIB%100==0)
			printf("%d\n", GIB);

		if ((GIB>GNUM) && (GIB%SS==0)) {
			for (k=1; k<=2; k++) {
				for (zc=1; zc<NC[k]; zc++)
					for (i=1; i<NP[k]; i++) {
						EPA[k][zc][i]+=PA[k][zc][i];
						VPA[k][zc][i]+=PA[k][zc][i]*PA[k][zc][i];
					}
					
				for (i=1; i<NO; i++) {
					for (t=1; t<NT; t++) {
						EID[k][i][t][ZID[k][i][t]]++;
						
						for (j=1; j<NK[k]; j++)
							EOmega[k][i][j][t]+=Omega[k][i][j][t];
					}
				
					for (t=1; t<NT; t++) {
						zc=ZID[k][i][t];
						
						m=0;
						
						tmp1=tmp2=tmp3=0;
						
						for (j=1; j<NY[k]; j++) {
							
							temp=MU[k][zc][j];
							
							for (l=1; l<NK[k]; l++)
								temp+=LY[k][zc][j][l]*Omega[k][i][l][t];

							FI[k][i][1]+=1-(YO[k][i][j][t]-temp)*YO[k][i][j][t]/PSX[k][zc][j];
							// Scheme 1: Multiplicative YO
							
							FI[k][i][2]+=0.5-0.5*(YO[k][i][j][t]-temp)*(YO[k][i][j][t]-temp)/PSX[k][zc][j];
							// Scheme 2: Perturbation of the observed-data log-likelihood
							
							tmp1=phi[k][zc][1]+phi[k][zc][2]*YO[k][i][j][t];
							
							for (l=1; l<NX; l++)
								tmp1+=phi[k][zc][2+l]*AZ[i][l][t];
							
							tmp2=exp(tmp1);
							
							tmp3=phi[k][zc][2]*YO[k][i][j][t];
							
							FI[k][i][1]+=IYY[k][i][j][t]*tmp3-tmp2*tmp3/(1+tmp2);
							FI[k][i][2]+=0.5*IYY[k][i][j][t]*tmp3-0.5*tmp2*tmp3/(1+tmp2);
							// Schemes 1 and 2: Non-ignorable missing terms
							
						}
						
						for (j=1; j<NB[k]-NZ[k]+1; j++)
							for (l=1; l<NM[k]; l++) {
								temp=Eta[k][i][l][t];
								
								for (n=1; n<NZ[k]; n++)
									temp-=BI[k][zc][l][n]*XI[k][i][n][t];
								
								n=NZ[k]+j-1;
								FI_stru[k][zc][j]+=temp*XIB[k][i][n][t]/PSD[k][zc][l];
							}
					
						temp=exp(phi[k][zc][1]);
						
						for (j=1; j<NY[k]; j++) {
							FI_miss[k][zc][1]+=IYY[k][i][j][t]*YO[k][i][j][t]-temp*YO[k][i][j][t]/(1+temp);
							
							for (l=1; l<NX; l++)
								FI_miss[k][zc][1+l]+=IYY[k][i][j][t]*AZ[i][l][t]-temp*AZ[i][l][t]/(1+temp);
						}

						// Perturbation of nonignorable sampling distribution
					}

					for (t=2; t<NT; t++) {
						zc=ZID[k][i][t];

						if (zc<NC[k]-1) {
							temp=1;
							
							for (j=1; j<=zc; j++)
								temp-=exp(ALPHA[k][zc][j])/(1+exp(ALPHA[k][zc][j]));
						}
						else {
							temp=0;
							
							for (j=1; j<NC[k]; j++)
								temp-=exp(ALPHA[k][zc][j])/(1+exp(ALPHA[k][zc][j]));
						}
						
						for (j=1; j<NX; j++)
							FI_tran[k][j]+=temp*AZ[i][j][t];
					}
					// Perturbation of the sampling distribution in the transition model						
				}
				
				for (zc=1; zc<NC[k]; zc++) {
					for (j=1; j<NY[k]; j++) {
						FI_prior[k][1]+=0.5-0.5*(MU[k][zc][j]-PMU[k][zc][j])*(MU[k][zc][j]-PMU[k][zc][j])*sigmu;
						// Perturbation of MU
						
						for (l=1; l<NK[k]; l++)
							if (IDY[k][j][l])
								FI[k][1][2]-=0.5*(LY[k][zc][j][l]-PLY[k][zc][j][l])*(LY[k][zc][j][l]-PLY[k][zc][j][l])*sigly/PSX[k][zc][j];
						
						FI_prior[k][2]+=0.5*ROY[k][j];
						// Perturbation of LY							
					}
					
					for (j=1; j<NM[k]; j++) {
						for (l=1; l<NB[k]; l++)
							FI_prior[k][3]-=0.5*(BI[k][zc][j][l]-PBI[k][zc][j][l])*(BI[k][zc][j][l]-PBI[k][zc][j][l])*sigbi/PSD[k][zc][j];
						
						FI_prior[k][3]+=0.5*(NB[k]-1);
						// Perturbation of BI						
					}
				}
					
				i=3;
					
				for (j=1; j<NY[k]; j++)	{
					i++;
					for (zc=1; zc<NC[k]; zc++)
						FI_prior[k][i]+=PALPA[k][zc][j]-PBETA[k][zc][j]*1.0/PSX[k][zc][j];							
				}
				// Perturbation of PSX[j]
				
				for (j=1; j<NM[k]; j++)	{
					i++;
					for (zc=1; zc<NC[k]; zc++)
						FI_prior[k][i]+=PALP[k][zc][j]-PBET[k][zc][j]*1.0/PSD[k][zc][j];
				}
				// Perturbation of PSD[j]
				
				i++;
				for (zc=1; zc<NC[k]-1; zc++)
					for (l=1; l<2+NX; l++)
						FI_prior[k][i]-=0.5*(phi[k][zc][l]-pphi[k][zc][l])*(phi[k][zc][l]-pphi[k][zc][l])*sigphi;
					
				FI_prior[k][i]+=0.5*(1+NX)*(NC[k]-1);
				// Perturbation of phi
				
				i++;
				for (zc=1; zc<NC[k]-1; zc++)
					FI_prior[k][i]-=0.5*(ALPHA[k][zc][0]-PALPHA[k][zc][0])*(ALPHA[k][zc][0]-PALPHA[k][zc][0])*sigalp;
					
				FI_prior[k][i]+=0.5*(NC[k]-2);
				// Perturbation of ALPHA[k][zc][0]
				
				i++;
				for (zc=1; zc<NC[k]-1; zc++)
					for (j=1; j<NC[k]; j++)
						FI_prior[k][i]-=0.5*(ALPHA[k][zc][j]-PALPHA[k][zc][j])*(ALPHA[k][zc][j]-PALPHA[k][zc][j])*sigalp2;

				FI_prior[k][i]+=0.5*(NC[k]-1)*(NC[k]-2);
				// Perturbation of ALPHA[k][zc][j]
				
				i++;
				for (j=1; j<NX; j++)
					FI_prior[k][i]+=0.5-0.5*(Gamma[k][j]-PGamma[k][j])*(Gamma[k][j]-PGamma[k][j])*siggam;
				// Perturbation of GAMMA			
			}
			
			calG2(AZ, ZID, YO, Omega, XIB, MU, LY, PSX, BI, PSD, PHI, phi, ALPHA, G, G_stru, G_miss, G_tran);
		}
	}

	for (k=1; k<=2; k++) {
		for (zc=1; zc<NC[k]; zc++) {
			for (i=1; i<NP[k]; i++) {
				EPA[k][zc][i]=EPA[k][zc][i]*SS/(MCAX-GNUM);
				VPA[k][zc][i]=sqrt(VPA[k][zc][i]*SS/(MCAX-GNUM)-EPA[k][zc][i]*EPA[k][zc][i]);
			}					
		}

		for (i=1; i<NO; i++) {
			for (t=1; t<NT; t++) {
				temp=0;
				for (j=1; j<NC[k]; j++)
					if (EID[k][i][t][j]>temp) {
						temp=EID[k][i][t][j];
						ZID[k][i][t]=j;
					}
				
				for (j=1; j<NK[k]; j++)
					EOmega[k][i][j][t]=EOmega[k][i][j][t]*SS/(MCAX-GNUM);
			}

			for (j=1; j<=2; j++) {

				FI[k][i][j]=FI[k][i][j]*SS/(MCAX-GNUM);
				
				G[k][i][j]=G[k][i][j]*SS/(MCAX-GNUM);

				FI[k][i][j]=FI[k][i][j]*FI[k][i][j]/G[k][i][j];
			}
		}

		for (j=1; j<=50; j++) {
			if (G_prior[k][j]==0)
				continue;
			
			FI_prior[k][j]=FI_prior[k][j]*SS/(MCAX-GNUM);

			FI_prior[k][j]=FI_prior[k][j]*FI_prior[k][j]/G_prior[k][j];
		}
		
		n=NC[k];
		
		for (j=1; j<NB[k]-NZ[k]+1; j++) {
			
			FI_stru[k][n][j]=0;
			
			for (zc=1; zc<NC[k]; zc++) {
				FI_stru[k][zc][j]=FI_stru[k][zc][j]*SS/(MCAX-GNUM);
				
				FI_stru[k][n][j]+=FI_stru[k][zc][j];

				for (l=1; l<=j; l++) {
					G_stru[k][zc][j][l]=G_stru[k][zc][j][l]*SS/(MCAX-GNUM);
					
					G_stru[k][n][j][l]+=G_stru[k][zc][j][l];
					
					G_stru[k][n][l][j]=G_stru[k][n][j][l];
				}
			}

			NYO[j]=FI_stru[k][n][j]*FI_stru[k][n][j];
		}
		
		iv(G_stru[k][n], NB[k]-NZ[k]+1);
		
		for (j=1; j<NB[k]-NZ[k]+1; j++) {
			FI_stru[k][n][j]=0;
			
			for (l=1; l<NB[k]-NZ[k]+1; l++)
				FI_stru[k][n][j]+=G_stru[k][n][j][l]*NYO[l];
		}
		
		for (j=1; j<1+NX; j++) {
			
			FI_miss[k][n][j]=0;
		
			for (zc=1; zc<NC[k]; zc++) {
				FI_miss[k][zc][j]=FI_miss[k][zc][j]*SS/(MCAX-GNUM);
			
				FI_miss[k][n][j]+=FI_miss[k][zc][j];
				
				for (l=1; l<=j; l++) {
					G_miss[k][zc][j][l]=G_miss[k][zc][j][l]*SS/(MCAX-GNUM);
					
					G_miss[k][n][j][l]+=G_miss[k][zc][j][l];
					
					G_miss[k][n][l][j]=G_miss[k][n][j][l];
				}
			}

			NYO[j]=FI_miss[k][n][j]*FI_miss[k][n][j];
		}

		iv(G_miss[k][n], 1+NX);
		
		for (j=1; j<1+NX; j++) {
			FI_miss[k][n][j]=0;
			
			for (l=1; l<1+NX; l++)
				FI_miss[k][n][j]+=G_miss[k][n][j][l]*NYO[l];
		}

		for (j=1; j<NX; j++) {
			
			FI_tran[k][j]=FI_tran[k][j]*SS/(MCAX-GNUM);
			
			NYO[j]=FI_tran[k][j]*FI_tran[k][j];
			
			for (l=1; l<=j; l++) {
				G_tran[k][j][l]=G_tran[k][j][l]*SS/(MCAX-GNUM);
				
				G_tran[k][l][j]=G_tran[k][j][l];
			}
		}

		iv(G_tran[k], NX);

		for (j=1; j<NX; j++) {
			FI_tran[k][j]=0;
			
			for (l=1; l<NX; l++)
				FI_tran[k][j]+=G_tran[k][j][l]*NYO[l];
		}
	}

	sdat1(EPA, 1);
	sdat1(VPA, 2);

	finish=clock();
	Time=(double)((finish-start)/CLOCKS_PER_SEC);		
	
	for (k=1; k<=1; k++) {
		sprintf(name, "%s%s", "log", ".txt");
		
		dat=fopen(name, "w");
					
		fprintf(dat, "\nAcceptance Rate of Gamma:");
		fprintf(dat, "%8.3f\n", Accept_GAM[k]*1.0/MCAX);
		
		fprintf(dat, "\nAcceptance Rate of ALP:\n");
		for (i=1; i<NC[k]; i++) {
			for (j=0; j<NC[k]; j++)
				fprintf(dat, "%8.3f", Accept_ALP[k][i][j]*1.0/MCAX);

			fprintf(dat, "\n");	
		}

		fprintf(dat, "\nAcceptance Rate of phi:");
		for (i=1; i<NC[k]; i++)
				fprintf(dat, "%8.3f", Accept_phi[k][i]*1.0/MCAX);

		fprintf(dat, "\n");	
		
		fprintf(dat, "\nAcceptance Rate of Omega:");
		fprintf(dat, "%8.3f\n", Accept_Omega[k]*1.0/((NO-1)*(NT-1)*MCAX));

		fprintf(dat, "\nAcceptance Rate of y:\n");
		for (i=1; i<NY[k]; i++)
			fprintf(dat, "%8.3f", Accept_y[k][i]*1.0/((NO-1)*(NT-1)*MCAX));
		fprintf(dat, "\n");

		fprintf(dat, "\nRunning Time(mins)=%16.3lf\n\n", Time/60);			

		fclose(dat);

		sprintf(name, "%s", "FI_S1.txt");
		
		dat=fopen(name, "w");

		for (i=1; i<NO; i++)
			fprintf(dat, "%16.3f\n", FI[k][i][1]);
		
		fclose(dat);
		
		sprintf(name, "%s", "FI_S2.txt");
		
		dat=fopen(name, "w");

		for (i=1; i<NO; i++)
			fprintf(dat, "%16.3f\n", FI[k][i][2]);
		
		fclose(dat);

		sprintf(name, "%s", "FI_stru.txt");
		
		dat=fopen(name, "w");

		zc=NC[k];
		
		for (i=1; i<NB[k]-NZ[k]+1; i++)
			fprintf(dat, "%16.3f\n", fabs(FI_stru[k][zc][i]));
			
		fclose(dat);
		
		sprintf(name, "%s", "FI_miss.txt");
		
		dat=fopen(name, "w");
		
		for (i=1; i<1+NX; i++)
			fprintf(dat, "%16.3f\n", fabs(FI_miss[k][zc][i]));
			
		fclose(dat);
		
		sprintf(name, "%s", "FI_tran.txt");
		
		dat=fopen(name, "w");
		
		for (i=1; i<NX; i++)
			fprintf(dat, "%16.3f\n", fabs(FI_tran[k][i]));
		
		fclose(dat);

		sprintf(name, "%s", "FI_prior.txt");
		
		dat=fopen(name, "w");	
		
		for (i=1; i<=3; i++)				
			fprintf(dat, "%16.3f\n", FI_prior[k][i]);
		
		temp=0;
		m=4;
		
		for (i=1; i<NY[k]; i++)
			temp+=FI_prior[k][m++];

		fprintf(dat, "%16.3f\n", temp);

		temp=0;
		
		for (i=1; i<NM[k]; i++)
			temp+=FI_prior[k][m++];
		
		fprintf(dat, "%16.3f\n", temp);
		
		for (i=1; i<=4; i++)
			fprintf(dat, "%16.3f\n", FI_prior[k][m++]);
		
		fclose(dat);

	}

	free_if3tensor(ZID, 1, 2, 1, NO, 1, NT);
	free_if3tensor(TID,1, 2, 1, NO, 1, NT);

	free_f3tensor(AZ, 1, NO, 1, NX, 1, NT);
	free_array4(YO, 1, 2, 1, NO, 1, NY2, 1, NT);
	free_array4(XO, 1, 2, 1, NO, 1, NY2, 1, NT);
	free_array4(TUE, 1, 2, 1, NO, 1, NK2, 1, NT);
	free_array4(Omega, 1, 2, 1, NO, 1, NK2, 1, NT);
	free_array4(Eta, 1, 2, 1, NO, 1, NM2, 1, NT);
	free_array4(XI, 1, 2, 1, NO, 1, NZ2, 1, NT);
	free_array4(XIB, 1, 2, 1, NO, 1, NB2, 1, NT);

	free_f3tensor(MU, 1, 2, 1, NC2, 1, NY2);
	free_array4(LY, 1, 2, 1, NC2, 1, NY2, 1, NK2);
	free_f3tensor(PSX, 1, 2, 1, NC2, 1, NY2);
	free_array4(THRES, 1, 2, 1, NC2, 1, NY2, 0, 2);
	free_array4(BI, 1, 2, 1, NC2, 1, NM2, 1, NB2);
	free_f3tensor(PSD, 1, 2, 1, NC2, 1, NM2);
	free_array4(PHI, 1, 2, 1, NC2, 1, NZ2, 1, NZ2);
	free_f3tensor(phi, 1, 2+NX, 1, NC2, 1, 2+NX);
	free_matrix(Gamma, 1, 2, 1, NX);
	free_f3tensor(ALPHA, 1, 2, 1, NC2, 0, NC2);

	free_f3tensor(EPA, 1, 2, 1, NC2, 1, NP2);
	free_f3tensor(VPA, 1, 2, 1, NC2, 1, NP2);
	free_f3tensor(PA, 1, 2, 1, NC2, 1, NP2);
	free_array4(EID, 1, 2, 1, NO, 1, NT, 1, NC2);
	free_array4(Pred, 1, 2, 1, NT, 1, NC2, 1, NC2);
	
	free_array4(EOmega, 1, 2, 1, NO, 1, NK2, 1, NT);

	free_array4(INPH, 1, 2, 1, NC2, 1, NZ2, 1, NZ2);
	free_matrix(NEYO, 1, NO, 1, NT);
	free_vector(NYO, 1, NY2);
	free_vector(GOmega, 1, NK2);
	free_vector(GAZ, 1, NX);
	free_array4(SIG, 1, 2, 1, NC2, 1, NK2, 1, NK2);
	free_array4(f, 1, 2, 1, NC2, 1, NO, 1, NT);
	free_f3tensor(AZGam, 1, 2, 1, NO, 1, NT);
	free_array5(PROP, 1, 2, 1, NO, 1, NT, 1, NC2, 0, NC2);

	free_ivector(NC, 1, 2);
	free_ivector(NY, 1, 2);
	free_ivector(NH, 1, 2);
	free_ivector(NK, 1, 2);
	free_ivector(NM, 1, 2);
	free_ivector(NZ, 1, 2);
	free_ivector(NB, 1, 2);
	free_ivector(NP, 1, 2);		

	free_imatrix(IND, 1, 2, 1, NY2);
	free_imatrix(ROAL, 1, 2, 1, NY2);
	free_if3tensor(IDY, 1, 2, 1, NY2, 1, NK2);
	free_if3tensor(CLY, 1, 2, 1, NY2, 1, NK2);
	free_imatrix(ROY, 1, 2, 1, NY2);
	free_array4(IYY, 1, 2, 1, NO, 1, NY2, 1, NT);
	free_imatrix(RefCate, 1, 2, 1, NC2);
	free_ivector(POS, 1, 2);

	free_f3tensor(PMU, 1, 2, 1, NC2, 1, NY2);
	free_array4(PLY, 1, 2, 1, NC2, 1, NY2, 1, NK2);
	free_array4(PBI, 1, 2, 1, NC2, 1, NM2, 1, NB2);
	free_matrix(PGamma, 1, 2, 1, NX);
	free_f3tensor(PALPHA, 1, 2, 1, NC2, 0, NC2);
	free_if3tensor(PALPA, 1, 2, 1, NC2, 1, NY2);
	free_if3tensor(PBETA, 1, 2, 1, NC2, 1, NY2);
	free_if3tensor(PALP, 1, 2, 1, NC2, 1, NM2);
	free_if3tensor(PBET, 1, 2, 1, NC2, 1, NM2);
	free_imatrix(RHO, 1, 2, 1, NC2);
	free_array4(RH, 1, 2, 1, NC2, 1, NZ2, 1, NZ2);
	free_f3tensor(pphi, 1, 2+NX, 1, NC2, 1, 2+NX);
	
	free_vector(VAR_Gam, 1, 2);
	free_f3tensor(VAR_ALP, 1, 2, 1, NC2, 1, NC2);
	free_f3tensor(VAR_THR, 1, 2, 1, NC2, 1, NY2);
	free_vector(VAR_Omega, 1, 2);
	free_matrix(VAR_phi, 1, 2, 1, NC2);
	free_matrix(VAR_y, 1, 2, 1, NY2);

	free_ivector(Accept_GAM, 1, 2);
	free_if3tensor(Accept_ALP, 1, 2, 1, NC2, 1, NC2);
	free_if3tensor(Accept_THR, 1, 2, 1, NC2, 1, NY2);
	free_ivector(Accept_Omega, 1, 2);
	free_imatrix(Accept_phi, 1, 2, 1, NC2);
	free_imatrix(Accept_y, 1, 2, 1, NY2);
	
	free_matrix(D1, 1, 2, 1, NO);
	free_vector(D2, 1, NO);
	free_vector(D3, 1, NO);
	
	free_f3tensor(FI, 1, 2, 1, NO, 1, 5);
	free_f3tensor(G, 1, 2, 1, NO, 1, 5);
	
	free_matrix(FI_prior, 1, 2, 1, 50);
	free_matrix(G_prior, 1, 2, 1, 50);
	
	free_f3tensor(FI_stru, 1, 2, 1, NC2, 1, NB2);
	free_array4(G_stru, 1, 2, 1, NC2, 1, NB2, 1, NB2);

	free_f3tensor(FI_miss, 1, 2, 1, NC2, 1, 1+NX);
	free_array4(G_miss, 1, 2, 1, NC2, 1, 1+NX, 1, 1+NX);

	free_matrix(FI_tran, 1, 2, 1, NX);
	free_f3tensor(G_tran, 1, 2, 1, NX, 1, NX);
	
	return 0;
}
