void newph(double **PHI, double **INPH, double ***XI, int **ZID, int rho, double **rh, int NZ, int zc)
{
	int i, j, k, l, t, num;
	long random;
	double **mxz, **TT, **Wsat, *PP;

	mxz=matrix(1, NK2, 1, NK2);
	TT=matrix(1, NK2, 1, NK2);
	Wsat=matrix(1, NK2, 1, NK2);
	PP=vector(1, NK2);

	for (i=1; i<NZ; i++)
		for (j=1; j<=i; j++)
			mxz[j][i]=mxz[i][j]=rh[i][j];

	num=0;
	
	for (i=1; i<NO; i++)
		for (t=1; t<NT; t++)
			if (ZID[i][t]==zc) {
				for (j=1; j<NZ; j++)
					for (k=1; k<=j; k++)
						mxz[j][k]+=XI[i][j][t]*XI[i][k][t];  
				num++;
			}
			
	for (j=1; j<NZ; j++)
		for (k=1; k<=j; k++)
			mxz[k][j]=mxz[j][k];
	// (\xi*\xi^T)
	
	iv(mxz, NZ);

	choldc(mxz, NZ-1, PP);     

	for (i=1; i<NZ; i++)
		mxz[i][i]=PP[i];
	
	for (i=1; i<NZ; i++) {
		k=(num+rho+1-i)/2;
		
		random=rand(); 
		TT[i][i]=sqrt(2.0*gamdev(k, &random));      
		
		for (j=1; j<i; j++) {
			random=rand();
			TT[i][j]=gasdev(&random);
			TT[j][i]=0;
		}
	}

	for (i=1; i<NZ; i++)   
		for (j=1; j<=i; j++) {
			Wsat[i][j]=0.0;
			for (k=1; k<=j; k++)
				Wsat[i][j]+=TT[i][k]*TT[j][k];
			Wsat[j][i]=Wsat[i][j];
		}
	// standard Wishart distribution

	for (i=1; i<NZ; i++) 
		for (j=1; j<=i; j++) {
			INPH[i][j]=0;
			for (k=1; k<=i; k++)
				for (l=1; l<=j; l++)
					INPH[i][j]+=mxz[i][k]*Wsat[k][l]*mxz[j][l];
			INPH[j][i]=INPH[i][j];
		}
		

	for (i=1; i<NZ; i++)
		for (j=1; j<=i; j++)
			PHI[j][i]=PHI[i][j]=INPH[i][j];

	iv(PHI, NZ);

	free_matrix(mxz, 1, NK2, 1, NK2);
	free_matrix(TT, 1, NK2, 1, NK2);
	free_matrix(Wsat, 1, NK2, 1, NK2);
	free_vector(PP, 1, NK2);

	return ;
}
