#include "tphi_non4.c"

int newphi_non4(int k, int zc, double *phi, double ***YO, double ***AZ, int **ZID, double VAR)
{
	int i, j, l, m, n, t;
	long random;
	double ****TT, **imaf, *PP, *diag, temp, rat1, rat2, ratio;

	TT=array4(1, NO, 1, 2+NX, 1, NY2, 1, NT);	
	imaf=matrix(1, 2+NX, 1, 2+NX);
	PP=vector(1, 2+NX);
	diag=vector(1, 2+NX);
	
	for (i=1; i<NO; i++)
		for (j=1; j<NY[k]; j++)
			for (t=1; t<NT; t++) {
				TT[i][1][j][t]=1;
				TT[i][2][j][t]=YO[i][j][t];
				
				for (l=1; l<NX; l++)
					TT[i][2+l][j][t]=AZ[i][l][t];
			}
	
	for (m=1; m<2+NX; m++) {
		imaf[m][m]=sigphi;
		for (n=1; n<m; n++)
			imaf[m][n]=0;
	}
	
	for (i=1; i<NO; i++)
		for (t=1; t<NT; t++)
			if (ZID[i][t]==zc) {
				for (m=1; m<2+NX; m++)
					for (n=1; n<=m; n++)
						for (j=1; j<NY[k]; j++)
							imaf[m][n]+=TT[i][m][j][t]*TT[i][n][j][t]/4.0;
			}
	
	for (m=1; m<2+NX; m++)
		for (n=1; n<=m; n++) {
			imaf[m][n]/=VAR;
			imaf[n][m]=imaf[m][n];
		}

	iv(imaf, 2+NX);

	choldc(imaf, 2+NX-1, diag);
	
	for (m=1; m<2+NX; m++) {
		imaf[m][m]=diag[m];
		random=rand();
		diag[m]=gasdev(&random);
	}

	for (m=1; m<2+NX; m++) {
		PP[m]=phi[m];
		for (n=1; n<=m; n++)
			PP[m]+=imaf[m][n]*diag[n];
	}

	rat1=tphi_non4(k, zc, phi, YO, AZ, ZID);
	rat2=tphi_non4(k, zc, PP,  YO, AZ, ZID);
	
	ratio=exp(rat1-rat2);
	
	random=rand();
	temp=ran2(&random);
	
	if (temp<=ratio) {
		for (m=1; m<2+NX; m++)
			phi[m]=PP[m];
		i=1;
	}
	else
		i=0;
	
	free_array4(TT, 1, NO, 1, 2+NX, 1, NY2, 1, NT);	
	free_matrix(imaf, 1, 2+NX, 1, 2+NX);
	free_vector(PP, 1, 2+NX);
	free_vector(diag, 1, 2+NX);	

	return i;
}
