double tomega(double *GN, double *GYO, double **LY, double *PSX, double **BI, double *PSD, double **INPH, int k)
{
	int i, j, l;
	double *GXI, *GXIB, temp;
	double ff, f1, f2, f3;

	GXI=vector(1, NZ2);
	GXIB=vector(1, NB2);

	f1=f2=f3=0;

	for (i=1; i<NY[k]; i++) {
		temp=GYO[i];
		for (j=1; j<NK[k]; j++)
			temp-=LY[i][j]*GN[j];
		f1+=temp*temp/PSX[i];
	}    
	// measurement equation

	for (j=1; j<NZ[k]; j++)
		GXI[j]=GN[j+NM[k]-1];

	for (j=1; j<NZ[k]; j++)
		GXIB[j]=GXI[j];
	
	GXIB[3]=GXI[1]*GXI[2];
	GXIB[4]=GXI[1]*GXI[1];
	GXIB[5]=GXI[2]*GXI[2];
	// nonlinear structural equation

	for (i=1; i<NZ[k]; i++) {
		f2+=GXI[i]*INPH[i][i]*GXI[i];
		for (j=1; j<i; j++)
		   f2+=GXI[i]*INPH[i][j]*GXI[j]*2;
	}
	// exogenous latent variable

	for (i=1; i<NM[k]; i++) {
		temp=GN[i];

		if (NON)
			for (j=1; j<NB[k]; j++)
				temp-=BI[i][j]*GXIB[j];
		else
			for (j=1; j<NZ[k]; j++)
				temp-=BI[i][j]*GXIB[j];

		f3+=temp*temp/PSD[i];
	}          
	// structural equation

	ff=0.5*(f1+f2+f3);

	free_vector(GXI, 1, NZ2);
	free_vector(GXIB, 1, NB2);

	return ff;
}
